# Save S3 external storage configuration

Endpoint: POST /externalStorage/s3
Version: 3.0.0
Security: bearerAuth, apiKeyAuth

## Security:

  - `bearerAuth` (unknown)
    http bearer Token

  - `apiKeyAuth` (unknown)
    apiKey in header Key

## Request fields (application/json):

  - `name` (string, required)
    Configuration name

  - `accessKey` (string)
    S3 access key

  - `accessKeySecret` (string)
    S3 access key secret

  - `directory` (string)
    Target directory path in the bucket

  - `s3Bucket` (string, required)
    S3 bucket name

  - `proxyEnabled` (boolean)
    Whether proxy is enabled for S3 access

  - `region` (string)
    AWS region

  - `isPrivate` (boolean)
    Whether the bucket is private

  - `roleArn` (string)
    IAM role ARN to assume

  - `directoryPattern` (string)
    Directory pattern for exports

  - `fileSuffixPattern` (string)
    File suffix pattern for exports

  - `assumeCustomerRole` (boolean)
    Whether to assume the customer IAM role after Sprinklr role assumption

## Response 200:

  - `200` (unknown)
    Success

## Response 200 fields (application/json):

  - `id` (string)
    External source id

  - `name` (string)
    Configuration name

  - `accessKey` (string)

  - `accessKeySecret` (string)

  - `directory` (string)
    Target directory path in the bucket

  - `s3Bucket` (string)
    S3 bucket name

  - `proxyEnabled` (boolean)
    Whether proxy is enabled for S3 access

  - `region` (string)
    AWS region

  - `isPrivate` (boolean)
    Whether the bucket is private

  - `roleArn` (string)
    IAM role ARN to assume

  - `directoryPattern` (string)
    Directory pattern for exports

  - `fileSuffixPattern` (string)
    File suffix pattern for exports

  - `assumeCustomerRole` (boolean)
    Whether to assume the customer IAM role after Sprinklr role assumption

  - `ownerUserId` (integer)
    Owner user id from the linked external source

## Response 400:

  - `400` (unknown)
    Bad request

## Response 400 fields (application/json):

  - `data` (object)

  - `errors` (array)

  - `errors.id` (string, required)
    24-character hex ObjectId

  - `errors.code` (integer, required)

  - `errors.message` (string, required)
    Dotted error key (e.g. account.not.found)

  - `metadata` (object)

## Response 401:

  - `401` (unknown)
    Missing or invalid authentication

## Response 401 fields (application/json):

  - `data` (object)

  - `errors` (array)

  - `errors.id` (string, required)
    24-character hex ObjectId

  - `errors.code` (integer, required)

  - `errors.message` (string, required)
    Dotted error key (e.g. account.not.found)

  - `metadata` (object)

## Response 403:

  - `403` (unknown)
    Insufficient permissions

## Response 403 fields (application/json):

  - `data` (object)

  - `errors` (array)

  - `errors.id` (string, required)
    24-character hex ObjectId

  - `errors.code` (integer, required)

  - `errors.message` (string, required)
    Dotted error key (e.g. account.not.found)

  - `metadata` (object)

## Response 404:

  - `404` (unknown)
    Resource not found

## Response 404 fields (application/json):

  - `data` (object)

  - `errors` (array)

  - `errors.id` (string, required)
    24-character hex ObjectId

  - `errors.code` (integer, required)

  - `errors.message` (string, required)
    Dotted error key (e.g. account.not.found)

  - `metadata` (object)

